// AnimationenView.h : interface of the CAnimationenView class
//
/////////////////////////////////////////////////////////////////////////////
// Vorwrtsdeklaration der Klassen (erspart includieren in alle anderen Dateien,
// die VektorgrafikenView.h includieren).
// Vorwrtsdeklaration der OpenGL-Animations-Klasse.
class COpenGLUniverse;
// Vorwrtsdeklaration der Visual-C++-Animations-Klasse.
class CGrueneWiese;

// Timeridentifikatoren.
#define OPENGLANIMATION 30
#define CPLUSANIMATION  40

class CAnimationenView : public CView
{
protected: // create from serialization only
	CAnimationenView();
	DECLARE_DYNCREATE(CAnimationenView)

// Attributes
public:
	CAnimationenDoc* GetDocument();

private:
	// OpenGL-Animations-Variablen.
	CClientDC*	     m_pDC;                  // Wird an das OpenGL-Objekt bergeben.
	COpenGLUniverse* m_pGLAni;               // Das OpenGL-Objekt.
	int              m_iViewSizeX;           // Gre der Sicht.
	int              m_iViewSizeY;
	UINT             m_uiWelcherGLButton1;   // Die Buttons der Palette, wenn die GL-Demo an-
	UINT             m_uiWelcherGLButton2;   // zeigt wird.
	int              m_iOpenGLBeobachterposition;  
	BOOL             m_bGLAniPlaneten;       // Flags, welche Animationen abgespielt werden
	BOOL             m_bGLAniBeobachter;     // sollen. Die GL-Demo besteht aus zwei Animationen.
	// Visual-C++-Animations-Variablen.
	CGrueneWiese*    m_pVCAni;               // Das Objekt der Visual-C++-Animation.
	UINT             m_uiWelcherVCButton;    // Die Buttons der Palette, wenn die VC-Demo
	                                         // angezeigt wird.

	// Allgemeine Variablen.
	BOOL             m_bIsOpenGL;            // Zeigt an, ob die GL-Demo abgespielt wird.
	BOOL             m_bIsCPlusDemo;         // Zeigt an, ob die C++-Demo abgespielt wird.
	UINT             m_uiTimer;              // Fr den Start des Timer bzw. lschen.

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAnimationenView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CAnimationenView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CAnimationenView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnUpdateOpenglDemo(CCmdUI* pCmdUI);
	afx_msg void OnOpenglDemo();
	afx_msg void OnUpdateCplusDemo(CCmdUI* pCmdUI);
	afx_msg void OnCplusDemo();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	afx_msg void OnUpdateGLPalette1(CCmdUI* pCmdUI);
	afx_msg void OnGLPalette1(UINT nID);
	afx_msg void OnUpdateGLPalette2(CCmdUI* pCmdUI);
	afx_msg void OnGLPalette2(UINT nID);
	afx_msg void OnUpdateVCPalette(CCmdUI* pCmdUI);
	afx_msg void OnVCPalette(UINT nID);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in AnimationenView.cpp
inline CAnimationenDoc* CAnimationenView::GetDocument()
   { return (CAnimationenDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
