// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Animationen.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_GETMINMAXINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// Button der OpenGL-Animation-Palette. Diese wird links im Fenster angezeigt.
static UINT BASED_CODE opengl[] =
{
	IDB_OPENGL_PLAY,
	IDB_OPENGL_STOP,
	IDB_OPENGL_PLAY2,
	IDB_OPENGL_STOP2
};
// Button der Visual-C++-Animation-Palette. Diese wird links im Fenster angezeigt.
static UINT BASED_CODE visualc[] =
{
	IDB_VC_PLAY,
	IDB_VC_STOP
};
/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// Modifizieren der Struktur "cs" ermglicht ein Verndern
	// des Fensters (Aussehen,Koordinaten), wenn es erzeugt wird
	cs.x=(-1);		// Das Fenster wird in der linken oberen Ecke geffnet
	cs.y=(-1);		// und ist immer 50x50 Pixel kleiner als die derzeitige Auflsung.
	cs.cy = ::GetSystemMetrics(SM_CYSCREEN) - 50;   // GetSystemMetrics (Win32) gibt die
    cs.cx = ::GetSystemMetrics(SM_CXSCREEN) - 50;   // Pixelgre des BS zurck.
	cs.style ^= WS_MAXIMIZEBOX ^ WS_MINIMIZEBOX;    // Kein MIN-MAX-Button.
	cs.dwExStyle |= WS_EX_TOPMOST;                  // ber allen anderen Fenstern.

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// Die Palette fr die OpenGL-Animation wird erstellt (unsichtbar).
	if (!m_wndOpenGLBox.Create(this, WS_CHILD | CBRS_SIZE_FIXED |
		CBRS_LEFT | CBRS_TOOLTIPS | CBRS_FLYBY, ID_OPENGLBAR) ||
		!m_wndOpenGLBox.LoadBitmap(IDB_OPENGLPALETTE) ||
		!m_wndOpenGLBox.SetButtons(opengl, sizeof(opengl) / sizeof(UINT)))
	{
		TRACE0("Toolbox fr die GL-Animation konnte nicht erstellt werden\n");
		return -1;       // fail to create
	}
	// Nachfolgende Sequenz ndert die Gre der OpenGL-Toolbox-Button. Standardgre fr die
	// Bitmaps ist 16x15, fr die Buttons 23x22.
	SIZE sizeButton, sizeImage;
	sizeButton.cx = 27;
	sizeButton.cy = 26;
	sizeImage.cx  = 20;
	sizeImage.cy  = 19;
	m_wndOpenGLBox.SetSizes(sizeButton, sizeImage);
	// Wieviele Buttons hat die Toolbox (knnte hier auch fest gesetzt werden).
	int iAnzahlButtons = m_wndOpenGLBox.GetToolBarCtrl().GetButtonCount();
	// Button-Style einstellen.
	for (int i = 0; i < iAnzahlButtons; i++)
	{
		// Um eine zweispaltige Toolbox zu erhalten mu jeder zweite Button
		// "umgebrochen" werden. Dies leistet der Style "TBBS_WRAPPED", wenn er
		// normal verodert wird. Ansonsten wird er mit dem Komplement verundet.
		UINT uiButtonStyle = m_wndOpenGLBox.GetButtonStyle(i);  // Bevor "SetButtonStyle"
		BOOL bWrap = (((i + 1) % 2) == 0);                    // benutzt wird, mu
		if (bWrap)											  // "GetButtonStyle" aufgerufen
			uiButtonStyle |= TBBS_WRAPPED;                    // werden.
		else
			uiButtonStyle &= ~TBBS_WRAPPED;                   // Sicherheitshalber.
		m_wndOpenGLBox.SetButtonStyle(i, uiButtonStyle);
	}
	
	// Die Palette der Visual-C++-Animation wird erstellt (unsichtbar).
	if (!m_wndVCBox.Create(this, WS_CHILD | CBRS_SIZE_FIXED |
		CBRS_LEFT | CBRS_TOOLTIPS | CBRS_FLYBY, ID_VCBAR) ||
		!m_wndVCBox.LoadBitmap(IDB_VCPALETTE) ||
		!m_wndVCBox.SetButtons(visualc, sizeof(visualc) / sizeof(UINT)))
	{
		TRACE0("Toolbox fr die Visual-C++-Animation konnte nicht erstellt werden\n");
		return -1;       // fail to create
	}
	// Nachfolgende Sequenz ndert die Gre der VC-Animation-Toolbox-Button.
	// Standardgre fr die Bitmaps ist 16x15, fr die Buttons 23x22.
	m_wndVCBox.SetSizes(sizeButton, sizeImage);

	return 0;
}

// Einstellen der Mindestgre des Fensters des MAIN-Frame.
void CMainFrame::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	// Die MINMAXINFO-Struktur kann dahingehend gendert werden, da das Hauptfenster
	// eine Mindestgre einhlt. In diesem Fall sind es 800x600 Pixel.
	lpMMI->ptMinTrackSize.x = 875;
	lpMMI->ptMinTrackSize.y = 655;
	CFrameWnd::OnGetMinMaxInfo(lpMMI);
}
